// Copyright (C) [2009] [Robin und Detlef Wolf]
// This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.geom.AffineTransform;
import java.awt.image.ImageObserver;

public class Car {

  private Image image;
  AffineTransform m_affineTransform = new AffineTransform(); // put here to minimize object creation
  
  private Color color ;
  
  public Car(Color color, Image image) {
  	this.image = image ;
  	this.color = color ;
  }
  
  public Color getColor() {
  	return color ;
  }
  
	void draw(Graphics2D g2d, int x, int y, double angle, ImageObserver obs) {
		// seen from the car's perspective, the last translation is applied first (!)
	  m_affineTransform.setToTranslation(x, y) ;
		m_affineTransform.scale(0.3, 0.3) ;
		m_affineTransform.rotate(-angle) ; // minus, because Java's coordinate
		                                   // system has origin in the upper left corner
		m_affineTransform.translate(-image.getWidth(obs)/2, 
				                        -image.getHeight(obs)/2) ;
		g2d.drawImage(image, m_affineTransform, obs); 
	}
} 

