// Copyright (C) [2009] [Robin und Detlef Wolf]
// This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.



import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.geom.AffineTransform;
import java.awt.image.ImageObserver;

public class CarCrash {

  private Image image;
  AffineTransform affineTransform = new AffineTransform(); // minimize object creation
  
  public CarCrash(Image image) {
  	this.image = image ;
  }
  
 	void draw(Graphics2D g2d, int x, int y, ImageObserver obs) {
		// keep this in sync with Car.java
		affineTransform.setToTranslation(x, y) ;
		affineTransform.scale(0.3, 0.3) ;
		affineTransform.translate(-image.getWidth(obs)/2, 
			                        -image.getHeight(obs)/2) ;
		g2d.drawImage(image, affineTransform, obs); 
	}
} 

