// Copyright (C) [2009] [Robin und Detlef Wolf]
// This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

@SuppressWarnings("serial")
public class VRStatus extends JPanel implements VRObserver {
  final VRModel m ;
 	JButton readyButton = new JButton("Strecke fertig") ;
	JLabel stateLabel = new JLabel("?") ;
	JButton playAgainButton = new JButton("Nochmal Spielen") ;
	JButton twoPlayerButton = new JButton("2 Spieler") ;
	JButton threePlayerButton = new JButton("3 Spieler") ;
	
	public VRStatus(VRModel m1) {
  	m = m1 ;
  	setLayout(new FlowLayout()) ;

  	add(stateLabel) ;
  	add(readyButton) ;
  	add(playAgainButton) ;
  	add(twoPlayerButton) ;
  	add(threePlayerButton) ;
  	
  	class PlayAgainButtonActionListener implements ActionListener {
  		public void actionPerformed(ActionEvent e) {
  			m.playAgain() ;
  		}
  	}
  	ActionListener playAgainButtonActionListener = new PlayAgainButtonActionListener() ;
  	playAgainButton.addActionListener(playAgainButtonActionListener) ;
  	
   	class ReadyButtonActionListener implements ActionListener {
  		public void actionPerformed(ActionEvent e) {
  			m.setRaceMode(true) ;
  		}
  	}
  	ActionListener readyButtonActionListener = new ReadyButtonActionListener() ;
  	readyButton.addActionListener(readyButtonActionListener) ;
  	
  	class TwoPlayerButtonActionListener implements ActionListener {
  		public void actionPerformed(ActionEvent e) {
  			m.setNumPlayers(2) ;
  		}
  	}
  	ActionListener twoPlayerButtonActionListener = new TwoPlayerButtonActionListener() ;
  	twoPlayerButton.addActionListener(twoPlayerButtonActionListener) ;
  	
  	class ThreePlayerButtonActionListener implements ActionListener {
  		public void actionPerformed(ActionEvent e) {
  			m.setNumPlayers(3) ;
  		}
  	}
  	ActionListener threePlayerButtonActionListener = new ThreePlayerButtonActionListener() ;
  	threePlayerButton.addActionListener(threePlayerButtonActionListener) ;
  	
  	
  	m.addObserver((VRObserver)this) ;
  	modelChanged() ;
  }

	public void modelChanged() {
		stateLabel.setText(m.isRaceMode ? "Rennen luft!" : "Strecke bauen ...") ;
		readyButton.setEnabled(!m.isRaceMode) ;
	}
}
