// Copyright (C) [2009] [Robin und Detlef Wolf]
// This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.


public class Vektor {
  public int x ;  // start point
  public int y ;  // start point
  public int dx ; // delta x
  public int dy ; // delta y
  
  public Vektor(int x, int y, int dx, int dy) {
  	this.x = x ;
  	this.y = y ;
  	this.dx = dx ;
  	this.dy = dy ;
  }
  
  public String toString() {
  	return "Vektor x="+x+" y="+y+" dx="+dx+" dy="+dy ;
  }
  
  public double getAngle(double xscale, double yscale) {
  	// the scale factors are needed to adapt account for the 
  	// different scales of the axis between 'block world'
  	// and drawing panel on the screen
 		return Math.atan2(yscale * (double)dy, xscale * (double)dx) ;
  }
  
  public boolean hasSameEndPoint(Vektor v) {
  	return (x + dx == v.x + v.dx)
  	       && (y + dy == v.y + v.dy) ; 
  }
}